** January 29, 2019
** ITT results

*******************************************************
*********** MODELS AND GRAPHS FOR PAPER ***************
*******************************************************

clear all
global QJPSfigures "/Users/zhaosongruan/Desktop/20045/figures"
global QJPSendline "/Users/zhaosongruan/Desktop/20045/endline"
global QJPSdofiles "/Users/zhaosongruan/Desktop/20045/do_files"
global QJPStables "/Users/zhaosongruan/Desktop/20045/tables"
global QJPSreplication "/Users/zhaosongruan/Desktop/20045"

*qui do "$QJPSdofiles\endline_ITTsetupv2.do"
qui do "$QJPSdofiles/models_in1column_v2.do"

** Controls macros (from endlinev2.do)
global controls q2 q6 q7 q9* q12new q14_1 q14_2 region_1 region_2 region_4 
global controlsgov "q2 q6 q7 q9* q12new q14_1 q14_2 region_1 region_2 region_4 if q11==0 & q8<5"
global controlsgames "q2 q6 q7 q9* q12new q14_1 q14_2 region_1 region_2 region_4 if q8<5"
macro dir

global esttabformatse b(%8.2f) obs se(%8.2f) ar2(%8.2f) r2(%8.2f) star(+ 0.10 * 0.05 * 0.01) 

use "$QJPSendline/endline.dta"

* Hall dummies
capture drop lum2q26
gen lum2q26 = 0 if inlist(q26,3)
label var lum2q26 "Lumumba"
replace lum2q26 = 1 if q26==4
capture drop ms2q26
gen ms2q26 = 0 if inlist(q26,1)
replace ms2 = 1 if q26==5
label var ms2q26 "Mary Stuart"

** Recode "back" to 0 now vs. 1 later so that beta>0 is more patient!
recode q32 (1=0) (0=1)
label drop Q32
label define Q32 0 "A payment of 50,000ugx now" 1 "A payment of 70,000ugx in a WEEK from now" 
label values q32 Q32
recode q33 (1=0) (0=1)
label drop Q33
label define Q33 0 "A payment of 50,000ugx now" 1 "A payment of 90,000ugx in a MONTH from now" 
label values q33 Q33



* Trust ITT results

foreach x in a a2 b c d e {
qui eststo q37`x'_lum2q26: reg q37`x' lum2q26 $controls
qui eststo q37`x'_ms2q26: reg q37`x' ms2q26 $controls
}
qui eststo q25stud_lum2q26: reg q25stud lum2q26 $controls
qui eststo q25stud_ms2q26: reg q25stud ms2q26 $controls

foreach var of varlist q37a q37a2 q37b q37c q37d q37e q25stud{
mergemodels `var'_lum2q26 `var'_ms2q26 
eststo `var'_lummsq26
estadd local N = "`e(`var'_lum2q26_N)'/`e(`var'_ms2q26_N)'"
estadd local R2 = "`:di %3.2f e(`var'_lum2q26_R2)'/`:di %3.2f e(`var'_ms2q26_R2)'"
}

cd "$QJPStables"
esttab q37a_lummsq26 q37a2_lummsq26 q37b_lummsq26 q37c_lummsq26 q37d_lummsq26 ///
q37e_lummsq26 q25stud_lummsq26 using trust_lummsq26.tex, ///
replace label varlabels(, elist(ms2 \hline)) ///
stats(N R2, fmt(0 2) labels("N" "\(R^{2}\)")) b(2) se(2) r2(2) nonotes star(\dag 0.10 * 0.05 ** 0.01) ///
mtitles("\shortstack{Hall\\residents}" "\shortstack{Partner\\hall}" "\shortstack{Makerere\\students}" "\shortstack{Makerere\\police force}" ///
"\shortstack{Dean of\\Students}" "\shortstack{Vice-\\Chancellor}" "\shortstack{Academic\\misconduct}") /// 
indicate("Controls = q2") nogaps keep(lum2q26 ms2q26) order(lum2q26 ms2q26) // refcat(lum2 "", nolabel) 


* Time prefs and hall identity ITT results

foreach var of varlist q32 q33 {
foreach x in lum ms {
qui eststo `var'_`x'2q26: reg `var' `x'2q26 $controls
}
}

foreach var of varlist q32 q33{
mergemodels `var'_lum2q26 `var'_ms2q26
eststo `var'_lummsq26
estadd local N = "`e(`var'_lum2q26_N)'/`e(`var'_ms2q26_N)'"
estadd local R2 = "`:di %3.2f e(`var'_lum2q26_R2)'/`:di %3.2f e(`var'_ms2q26_R2)'"
}

qui eststo q64_lum2q26: reg q64 lum2q26 $controls
qui eststo q64_ms2q26: reg q64 ms2q26 $controls
qui eststo q18_lum2q26: reg q18 lum2q26 $controls
qui eststo q18_ms2q26: reg q18 ms2q26 $controls

foreach var of varlist q64 q18{
mergemodels `var'_lum2q26 `var'_ms2q26
eststo `var'_lummsq26
estadd local N = "`e(`var'_lum2q26_N)'/`e(`var'_ms2q26_N)'"
estadd local R2 = "`:di %3.2f e(`var'_lum2q26_R2)'/`:di %3.2f e(`var'_ms2q26_R2)'"
}

cd "$QJPStables"
esttab q64_lummsq26 q18_lummsq26 q32_lummsq26 q33_lummsq26 ///
using identity_timedisc_lummsq26.tex, replace label varlabels(, elist(ms2 \hline)) ///
stats(N R2, fmt(0 2) labels("N" "\(R^{2}\)")) ///
b(2) se(2) r2(2) nonotes star(\dag 0.10 * 0.05 ** 0.01) ///
mtitles("\shortstack{Hall identity}" "\shortstack{Ethnic identity}" ///
"\shortstack{Now vs. in 1 week}" "\shortstack{Now vs. in 1 month}") /// 
indicate("Controls = q2") ///
eqlabels(none) nogaps nonotes keep(lum2q26 ms2q26) order(lum2q26 ms2q26) // refcat(lum2 "" ms2 "", nolabel) 
