global QJPSfigures "/Users/zhaosongruan/Desktop/20045/figures"
global QJPSendline "/Users/zhaosongruan/Desktop/20045/endline"

use "$QJPSendline/endline.dta", clear
drop if nm == 1 
drop if comp == 0 | comp == . 

* Hall dummies
capture drop liv3 lum3 lum2
gen liv3 = 0 if inlist(q28male,4,6)
label var liv3 "Livingstone 3"
replace liv3 = 1 if q28male==3
gen lum3 = 0 if inlist(q28male,3,6)
label var lum3 "Lumumba 3"
replace lum3 = 1 if q28male==4
gen lum2 = 0 if inlist(q28male,3)
label var lum2 "Lumumba"
replace lum2 = 1 if q28male==4
capture drop afr3 ms3 ms2
gen afr3 = 0 if inlist(q28fem,2,5)
label var afr3 "Africa 3"
replace afr3 = 1 if q28fem==1
gen ms3 = 0 if inlist(q28fem,1,2)
label var ms3 "Mary Stuart 3"
replace ms3 = 1 if q28fem==5
gen ms2 = 0 if inlist(q28fem,1)
label var ms2 "Mary Stuart"
replace ms2 = 1 if q28fem==5

** Controls macros
global controls "q2 q6 q7 q9* q12new q14_1 q14_2 region_1 region_2 region_4 if q8<5"
global controlsgov "q2 q6 q7 q9* q12new q14_1 q14_2 region_1 region_2 region_4 if q11==0 & q8<5"
global controlsgames "q2 q6 q7 q9* q12new q14_1 q14_2 region_1 region_2 region_4 if q8<5"
macro dir
reg q32 lum2 $controls
reg q32 lum2 $controlsgov

* Recode of campus activism variables from 1-4 to 0-3
capture drop q38*new
foreach var of varlist q38* {
gen `var'new = `var'
replace `var'new = `var'-2
replace `var'new = 0 if `var'new == -1
}
tab1 q38a* q38b* q38c* q38d*, nol

** Recode "back" to 0 now vs. 1 later so that beta>0 is more patient instead of less patient
recode q32 (1=0) (0=1)
label drop Q32
label define Q32 0 "A payment of 50,000ugx now" 1 "A payment of 70,000ugx in a WEEK from now" 
label values q32 Q32
recode q33 (1=0) (0=1)
label drop Q33
label define Q33 0 "A payment of 50,000ugx now" 1 "A payment of 90,000ugx in a MONTH from now" 
label values q33 Q33
