** OVER TIME ANALYSIS

global QJPSfigures "/Users/zhaosongruan/Desktop/20045/figures"
global QJPSendline "/Users/zhaosongruan/Desktop/20045/endline"
global QJPSdofiles "/Users/zhaosongruan/Desktop/20045/do_files"
global QJPStables "/Users/zhaosongruan/Desktop/20045/tables"
global QJPSreplication "/Users/zhaosongruan/Desktop/20045"
global QJPSalumni "/Users/zhaosongruan/Desktop/20045/alumni_survey"
macro dir

clear all 
set more off 

cd "$QJPSalumni"
use "alumni_final.dta"


* Generate a five-year moving average for ACTIVISM
sort hall_reside first_year
*ssc install rangestat 
capture drop movingmean_*
rangestat movingmean_demo = action_demo4, interval(first_year -2 2) by(hall_reside)
sort hall_reside first_year
list hall_reside first_year action_demo4 movingmean* in 1/30, sepby(hall_reside first_year) 

** TRUST
capture drop movingmean_trust*
local trustvars trust_hall trust_mak trust_univ trust_loan_new log_trust_loan 
foreach var of varlist `trustvars' {
rangestat movingmean_`var' = `var', interval(first_year -2 2) by(hall_reside) 
}

capture drop movingmean_demo1-movingmean_demo8 movingmean_trust_* 
local hallnum "1 3 4 5 8"
local hallname "Africa Livingstone Lumumba MaryStuart Northcote"
di "`hallname'"
local n : word count `hallnum'
forvalues i = 1/`n' {
local a : word `i' of `hallnum'
local b : word `i' of `hallname'
local trustvars trust_hall log_trust_loan 
foreach outcome in demo `trustvars' {
qui gen movingmean_`outcome'`a' = movingmean_`outcome' if hall_reside == `a'
label var movingmean_`outcome'`a' "`b'"
}
}
* since too few obs before 1975:
gen first_year76 = first_year if first_year > 1975 // up to 1975 few obs/noise


* Activism graph
graph twoway line movingmean_demo1 movingmean_demo3 movingmean_demo4 movingmean_demo5 first_year76, ///
graphregion(color(white)) /// margin(l=1 b=1) xscale(range(1975 2000)) ///
ylab(0(0.5)1.5) xscale(range(1975(5)2000)) ///
lcolor(navy navy maroon maroon) lwidth(0.45 ..) ///
lpattern(shortdash longdash_dot longdash_dot shortdash) ///
ytitle("Demonstrations attended/student" "(5-year moving average)", size(medium))  /// 
xtitle("Year student joined Makerere", size(medium))  /// 
legend(off) ///
text(1.15 1995 "Lumumba", place(c)) /// color(maroon)
text(.6 1995 "Mary Stuart", place(c)) /// color(maroon)
text(0.95 1995 "Livingstone", place(c)) ///color(navy)
text(0.4 1995 "Africa", place(c)) // color(navy)
cd "$QJPSfigures"
graph export activism_year.pdf, replace


* Trust graph
graph twoway line movingmean_trust_hall1 movingmean_trust_hall3 ///  
movingmean_trust_hall4 movingmean_trust_hall5 first_year76, /// 
graphregion(color(white)) /// margin(l=1 b=1) xscale(range(1975 2000)) ///
ylab(2(0.5)3.5) xlab(1975(5)2000) ///
lcolor(navy navy maroon maroon) lwidth(0.45 ..) ///
lpattern(shortdash longdash_dot longdash_dot shortdash) ///
ytitle("Level of trust in hallmates" "(5-year moving average)", size(medium))  /// 
xtitle("Year student joined Makerere", size(medium)) ///
legend(off) ///
text(2.55 1994 "Lumumba", place(c)) /// color(maroon)
text(2.38 1995 "Mary Stuart", place(c)) /// color(maroon)
text(3.07 1996 "Livingstone", place(c)) ///color(navy)
text(2.85 1992 "Africa", place(c)) // color(navy)
cd "$QJPSfigures"
graph export trusthall_year.pdf, replace

